#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <sys/stat.h>
#include <sys/fcntl.h>
#include "eef_plugin.h"

static char *_string = NULL;
int _fd = 0;
char *cert_file = NULL;
aos_attribute_t* pemstring;
aos_context_t*   _context;
aos_attribute_t *_uid, *_gid;
char* _uid_str = "1000";
char* _gid_str = "1000";

EES_PL_RC plugin_initialize(int argc, char* argv[]){
  char *cert_file_name = "/.globus/usercert.pem";
  char *home = "";
  struct stat _stat;
  /* get home dir */
  home = getenv("HOME");
  if((cert_file = calloc(1, (sizeof(char) * (strlen(home) + strlen(cert_file_name) + 1))))){
    strcat(cert_file, home);
    strcat(cert_file, cert_file_name);
  } else {
    EEF_log(LOG_ERR, "Out of memory!\n");
    return EES_PL_FAILURE;
  }

	EEF_log(LOG_NOTICE, "Initializing example plugin!\n");
  if((_fd = open(cert_file, O_RDONLY)) == -1){
    EEF_log(LOG_ERR, "Cannot open file %s: %s\n", cert_file, strerror(errno));
  }

  if(fstat(_fd, &_stat) == -1){
    EEF_log(LOG_ERR, "Cannot stat file %s: %s\n", cert_file, strerror(errno));
    return EES_PL_FAILURE;
  }

  if(!(_string = calloc(1, (_stat.st_size+1)*sizeof(char)))){
    EEF_log(LOG_ERR, "Out of memory!");
    return EES_PL_FAILURE;
  }


  if((read(_fd, _string, _stat.st_size)) == -1){
    EEF_log(LOG_ERR, "Cannot read file %s\n", cert_file);
    return EES_PL_FAILURE;
  } else {
#ifdef HAVE_LONG_LONG_INT
    EEF_log(LOG_INFO, "Read %lld bytes from file '%s'\n", (long long int) _stat.st_size, cert_file);
#else
    EEF_log(LOG_INFO, "Read %ld bytes from file '%s'\n", (long int) _stat.st_size, cert_file);
#endif
    /*setObligation("my_pemstring", _string);*/
    /*pemstring = createAttribute();*/
    /*setAttributeId(pemstring, "my_pemstring");*/
    /*setAttributeValue(pemstring, _string, strlen(_string));*/

    /*if((context = getNextContext(ANY, NULL)) == NULL){*/
    /*context = createContext(ANY);*/
    /*addContext(context);*/
    /*}*/

    /*addAttribute(context, pemstring);*/


    return EES_PL_SUCCESS;
  }

  return EES_PL_FAILURE;
}

EES_PL_RC plugin_run(){
	EEF_log(LOG_NOTICE, "Getting 'pemstring'\n");

  pemstring = createAttribute();
  setAttributeId(pemstring, "my_pemstring");
  setAttributeValue(pemstring, _string, strlen(_string));

  if((_context = getNextContext(ANY, NULL)) == NULL){
    _context = createContext(ANY);
    addContext(_context);
  }

  addAttribute(_context, pemstring);

  /*context = getNextContext(ANY,NULL);*/
  /*while(pemstring = getNextAttribute(context)){*/
  /*if(getAttributeId(pemstring) == "my_pemstring"){*/
  /*eef_log(LOG_ERR, "my_pemstring: %s\n", getObligation("my_pemstring"));*/
  /*}*/
  /*}*/

	EEF_log(LOG_NOTICE, "Setting 'pemstring' leeg\n");
  /*setObligation("my_pemstring", "Leeggehaald\n");*/
  /*setObligation("foo", "barbaz");*/
	return EES_PL_SUCCESS;
}

EES_PL_RC plugin_terminate(){
  /*destroyObligation("my_pemstring");*/
  free(cert_file);
  if(_fd > 0){
    close(_fd);
    free(_string);
  }
  return EES_PL_SUCCESS;
}
