#include "eef_library.h"
#include "eef_aos.h"
#include "cgul/log_to_file/log_to_file.h"

#define NUMBER_OF_ALLOWED_POLICIES 0

int main (int argc, char* argv[]){
  char* config_file;
  if(argc > 1){
    config_file = argv[1];
  } else {
    config_file = "examples/example_1.pdl";
  }

  cgul_openlog("/tmp/test_app_log");
  cgul_set_ident("test_app");
  cgul_set_log_options(CGUL_SYSLOG | CGUL_LOGFILE | CGUL_STDERR | CGUL_STDDEBUG);

  cgul_log(LOG_INFO, "Parsing config file %s\n", config_file);

	if(EEF_init(config_file, cgul_log) == EES_FAILURE){
    EEF_log(LOG_ERR, "Failed to parse config file (%s), exiting...", config_file);
  } else {

    EEF_log(LOG_INFO, "Modules path: %s\n", EEF_get_modules_path());
    /*setObligation("test", "foobar");*/
    if(EEF_run() == EES_FAILURE){
      EEF_log(LOG_ERR, "Failed to load and initialize all plugins in config file (%s), exiting...", config_file);
    }
    aos_dump_argslist();
  }
  EEF_term();
  cgul_closelog();
  return 0;
}
